#include <stdio.h>

void test1()
{
	int i;
	for(i=0;i<100000;i++)
		printf("%d\r",i);
}

void test2()
{
	char a = 'A';
	//char a = 65;
	a+=1;
	printf("%d\n",a);
	printf("%c\n",a);
}

void test3()
{
	float f = -35.264725f;
	printf("%f\n",f);
	printf("%d\n",f);
	printf("%d\n",(int)f);
}

void test4()
{
	int i;
	float f = 1.1519612f;
	printf("%f\n",f);
	printf("%.7f\n",f);
	printf("%.2f\n",f);
	printf("%.3f\n",f);
	i = 5;
	printf("%.*f\n",i,f);
	i = 1;
	printf("%.*f\n",i,f);
}

void test5()
{
	int i;
	float f;
	int* p;
	i = 335;
	printf("%d\n",i);
	printf("%x\n",i);
	printf("%X\n",i);
	printf("%o\n",i);

	f = 3547.15f;
	printf("%f\n",f);
	printf("%e\n",f);
	printf("%E\n",f);

	p = &i;
	printf("%p\n",p);
	p = NULL;
	printf("%p\n",p);
}

void test6()
{
	printf("\a");
	printf("%%\n");
	printf("\\\n");
	printf("\"plouf\"\n");
	printf("\'plouf\'\n");
	printf("\x7F\n");
	printf("plouf\bm\n");
}

int main()
{
	test1();
	//test2();
	//test3();
	//test4();
	//test5();
	//test6();
	return 0;
}

/*!F
	Quelques exemples pour printf, dcoups en diffrents tests. Activez les au fur et a mesure en les dcommentant dans le main.

	test1 : l'utilisation \r pour revenir au dbut de la ligne est pratique, pour faire un pourcentage par exemple.
			On crit quelque chose, et \r remet au dbut de la ligne. Rcrire par dessus va craser ce qu'il y a dj.

	test2 :
			Voici un autre test intressant, qui montre l'importance du type de sortie. 
			Comme vous le savez, un char permet de stocker un caractre. En ralit, il contient un nombre.
			La preuve, je fais a+=1 sans soucis.
			Le caractre, lui, ne dpend que de l'affichage : si j'affiche avec %c, j'affiche le caractre, 
			mais si j'affiche avec %d la mme variable, j'affiche le nombre.
			D'ailleurs, si on commente la premire dclaration du char, et qu'on dcommente la deuxime, cela revient au mme.
			
			Rappelez vous, les '' veulent dire CODE ASCII DE. Ainsi, quand vous dites que char a = 'A', vous dites = CODE ASCII DE A, autrement dit 65 :
			le compilateur stocke 65 directement.
			(* certains me diront qu'il existe d'autres normes que l'ASCII, mais sur nos machines usuelles, on utilise l'ASCII)

	test3:
			Encore un petit test pour montrer l'importance du type d'affichage. 
			J'ai un float avec une certaine valeur dedans. Elle est code en tant que float. Pour les curieux, elle suit la norme IEEE 754
			http://fr.wikipedia.org/wiki/IEEE_754
			un float fait 4 octets sur nos machines. Or un int fait galement souvent 4 octets. Mais les donnes ne sont pas organises pareil dedans.
			Donc si je mets un %d pour afficher un float, la machine va prendre les 4 octets du float et les "dcoder" comme si c'tait un int. 
			Donc on obtient une valeur fausse.
			Par contre, si je passe (int)f en deuxime paramtre, alors il y a conversion du float en int, et ainsi la valeur sera bonne.
			Notez le suffixe f  la fin de -35.264725f; qui permet de dire explicitement au compilateur que je donne un float. Ne rien mettre voudrait dire 
			que je donne un double.

	test4:
			L'affichage d'un float affiche par dfaut 6 chiffres aprs la virgule. Mais cela peut tre change comme vous pouvez le voir sur l'exemple.
			Notez que printf arrondit et ne tronque pas : ainsi, a 3 chiffres aprs la virgule, on affiche 1.152 (et non 1.151) car le chiffre d'aprs est un 9 :
			nous sommes donc mathmatiquement plus prs de 1.152 que de 1.151
			Notez qu'il ne sert  rien de mettre %.100f : vous aurez bien vos 100 chiffres, mais la prcision d'un float (ou d'un double) n'tant pas assez bonne
			pour assurer autant de dcimales, les chiffres en plus seront indtermins. (ce sera soit des 0, soit n'importe quoi)
			La syntaxe %.*f veut dire qu'on donne la valeur en paramtre (ici i).
	test5:
			Quelques affichages, en hexa (avec majuscule ou minuscule pour les lettres), en octal, en notation scientifique (avec majuscule ou minuscule pour e)
			Ainsi que l'affichage des pointeurs.
	test6:
			Quelques caractres spciaux avec la rponse, dans l'ordre, aux questions suivantes :
			- comment faire un son avec printf
			- comment afficher le caractre %  (il suffit d'en mettre deux)
			- comment afficher une \  (il suffit d'en mettre deux)
			- comment afficher des "
			- comment afficher des '
			- comment afficher directement un code ASCII quand on connait le code en hexa
			- comment revenir d'un cran en arrire (comme la touche backspace)

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Utilisation avance de printf.
titreE: Advanced features for printf.
meta: C;printf;avanc
metaE: C;printf;features
desc: Un exemple fait de sous exemples parcourant les diverses fonctionnalits de printf
descE: Samples about using many features about printf.
cle: printf
parag: 1. Langage C
parag: 1.1. stdio.h
paragE: 1. C Language
paragE: 1.1. stdio.h
*/
